// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: telemetry/Battery.proto
// </auto-generated>
#pragma warning disable 1591, 0612, 3021, 8981
#region Designer generated code

using pb = global::Google.Protobuf;
using pbc = global::Google.Protobuf.Collections;
using pbr = global::Google.Protobuf.Reflection;
using scg = global::System.Collections.Generic;
namespace Battery {

  /// <summary>Holder for reflection information generated from telemetry/Battery.proto</summary>
  public static partial class BatteryReflection {

    #region Descriptor
    /// <summary>File descriptor for telemetry/Battery.proto</summary>
    public static pbr::FileDescriptor Descriptor {
      get { return descriptor; }
    }
    private static pbr::FileDescriptor descriptor;

    static BatteryReflection() {
      byte[] descriptorData = global::System.Convert.FromBase64String(
          string.Concat(
            "Chd0ZWxlbWV0cnkvQmF0dGVyeS5wcm90bxIHYmF0dGVyeRofZ29vZ2xlL3By",
            "b3RvYnVmL3RpbWVzdGFtcC5wcm90byL/AQoHQmF0dGVyeRIcCg9zdGF0ZV9v",
            "Zl9jaGFyZ2UYASABKAVIAIgBARITCgZjaGFyZ2UYAiABKAlIAYgBARIWCglk",
            "aXNjaGFyZ2UYAyABKAlIAogBARIhChR0b3RhbF9jaGFyZ2VkX2VuZXJneRgE",
            "IAEoCUgDiAEBEiQKF3RvdGFsX2Rpc2NoYXJnZWRfZW5lcmd5GAUgASgJSASI",
            "AQFCEgoQX3N0YXRlX29mX2NoYXJnZUIJCgdfY2hhcmdlQgwKCl9kaXNjaGFy",
            "Z2VCFwoVX3RvdGFsX2NoYXJnZWRfZW5lcmd5QhoKGF90b3RhbF9kaXNjaGFy",
            "Z2VkX2VuZXJneUJzChtjb20uY29kaWJseS5tb2RlbC50ZWxlbWV0cnlCDEJh",
            "dHRlcnlQcm90b8oCG0RvbWFpbk1vZGVsXFByb3RvXFRlbGVtZXRyeeICJ0Rv",
            "bWFpbk1vZGVsXFByb3RvXFRlbGVtZXRyeVxHUEJNZXRhZGF0YWIGcHJvdG8z"));
      descriptor = pbr::FileDescriptor.FromGeneratedCode(descriptorData,
          new pbr::FileDescriptor[] { global::Google.Protobuf.WellKnownTypes.TimestampReflection.Descriptor, },
          new pbr::GeneratedClrTypeInfo(null, null, new pbr::GeneratedClrTypeInfo[] {
            new pbr::GeneratedClrTypeInfo(typeof(global::Battery.Battery), global::Battery.Battery.Parser, new[]{ "StateOfCharge", "Charge", "Discharge", "TotalChargedEnergy", "TotalDischargedEnergy" }, new[]{ "StateOfCharge", "Charge", "Discharge", "TotalChargedEnergy", "TotalDischargedEnergy" }, null, null, null)
          }));
    }
    #endregion

  }
  #region Messages
  public sealed partial class Battery : pb::IMessage<Battery>
  #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      , pb::IBufferMessage
  #endif
  {
    private static readonly pb::MessageParser<Battery> _parser = new pb::MessageParser<Battery>(() => new Battery());
    private pb::UnknownFieldSet _unknownFields;
    private int _hasBits0;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pb::MessageParser<Battery> Parser { get { return _parser; } }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public static pbr::MessageDescriptor Descriptor {
      get { return global::Battery.BatteryReflection.Descriptor.MessageTypes[0]; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    pbr::MessageDescriptor pb::IMessage.Descriptor {
      get { return Descriptor; }
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Battery() {
      OnConstruction();
    }

    partial void OnConstruction();

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Battery(Battery other) : this() {
      _hasBits0 = other._hasBits0;
      stateOfCharge_ = other.stateOfCharge_;
      charge_ = other.charge_;
      discharge_ = other.discharge_;
      totalChargedEnergy_ = other.totalChargedEnergy_;
      totalDischargedEnergy_ = other.totalDischargedEnergy_;
      _unknownFields = pb::UnknownFieldSet.Clone(other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public Battery Clone() {
      return new Battery(this);
    }

    /// <summary>Field number for the "state_of_charge" field.</summary>
    public const int StateOfChargeFieldNumber = 1;
    private int stateOfCharge_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int StateOfCharge {
      get { if ((_hasBits0 & 1) != 0) { return stateOfCharge_; } else { return 0; } }
      set {
        _hasBits0 |= 1;
        stateOfCharge_ = value;
      }
    }
    /// <summary>Gets whether the "state_of_charge" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasStateOfCharge {
      get { return (_hasBits0 & 1) != 0; }
    }
    /// <summary>Clears the value of the "state_of_charge" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearStateOfCharge() {
      _hasBits0 &= ~1;
    }

    /// <summary>Field number for the "charge" field.</summary>
    public const int ChargeFieldNumber = 2;
    private string charge_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Charge {
      get { return charge_ ?? ""; }
      set {
        charge_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "charge" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasCharge {
      get { return charge_ != null; }
    }
    /// <summary>Clears the value of the "charge" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearCharge() {
      charge_ = null;
    }

    /// <summary>Field number for the "discharge" field.</summary>
    public const int DischargeFieldNumber = 3;
    private string discharge_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string Discharge {
      get { return discharge_ ?? ""; }
      set {
        discharge_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "discharge" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasDischarge {
      get { return discharge_ != null; }
    }
    /// <summary>Clears the value of the "discharge" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearDischarge() {
      discharge_ = null;
    }

    /// <summary>Field number for the "total_charged_energy" field.</summary>
    public const int TotalChargedEnergyFieldNumber = 4;
    private string totalChargedEnergy_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string TotalChargedEnergy {
      get { return totalChargedEnergy_ ?? ""; }
      set {
        totalChargedEnergy_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "total_charged_energy" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasTotalChargedEnergy {
      get { return totalChargedEnergy_ != null; }
    }
    /// <summary>Clears the value of the "total_charged_energy" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearTotalChargedEnergy() {
      totalChargedEnergy_ = null;
    }

    /// <summary>Field number for the "total_discharged_energy" field.</summary>
    public const int TotalDischargedEnergyFieldNumber = 5;
    private string totalDischargedEnergy_;
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public string TotalDischargedEnergy {
      get { return totalDischargedEnergy_ ?? ""; }
      set {
        totalDischargedEnergy_ = pb::ProtoPreconditions.CheckNotNull(value, "value");
      }
    }
    /// <summary>Gets whether the "total_discharged_energy" field is set</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool HasTotalDischargedEnergy {
      get { return totalDischargedEnergy_ != null; }
    }
    /// <summary>Clears the value of the "total_discharged_energy" field</summary>
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void ClearTotalDischargedEnergy() {
      totalDischargedEnergy_ = null;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override bool Equals(object other) {
      return Equals(other as Battery);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public bool Equals(Battery other) {
      if (ReferenceEquals(other, null)) {
        return false;
      }
      if (ReferenceEquals(other, this)) {
        return true;
      }
      if (StateOfCharge != other.StateOfCharge) return false;
      if (Charge != other.Charge) return false;
      if (Discharge != other.Discharge) return false;
      if (TotalChargedEnergy != other.TotalChargedEnergy) return false;
      if (TotalDischargedEnergy != other.TotalDischargedEnergy) return false;
      return Equals(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override int GetHashCode() {
      int hash = 1;
      if (HasStateOfCharge) hash ^= StateOfCharge.GetHashCode();
      if (HasCharge) hash ^= Charge.GetHashCode();
      if (HasDischarge) hash ^= Discharge.GetHashCode();
      if (HasTotalChargedEnergy) hash ^= TotalChargedEnergy.GetHashCode();
      if (HasTotalDischargedEnergy) hash ^= TotalDischargedEnergy.GetHashCode();
      if (_unknownFields != null) {
        hash ^= _unknownFields.GetHashCode();
      }
      return hash;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public override string ToString() {
      return pb::JsonFormatter.ToDiagnosticString(this);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void WriteTo(pb::CodedOutputStream output) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      output.WriteRawMessage(this);
    #else
      if (HasStateOfCharge) {
        output.WriteRawTag(8);
        output.WriteInt32(StateOfCharge);
      }
      if (HasCharge) {
        output.WriteRawTag(18);
        output.WriteString(Charge);
      }
      if (HasDischarge) {
        output.WriteRawTag(26);
        output.WriteString(Discharge);
      }
      if (HasTotalChargedEnergy) {
        output.WriteRawTag(34);
        output.WriteString(TotalChargedEnergy);
      }
      if (HasTotalDischargedEnergy) {
        output.WriteRawTag(42);
        output.WriteString(TotalDischargedEnergy);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(output);
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalWriteTo(ref pb::WriteContext output) {
      if (HasStateOfCharge) {
        output.WriteRawTag(8);
        output.WriteInt32(StateOfCharge);
      }
      if (HasCharge) {
        output.WriteRawTag(18);
        output.WriteString(Charge);
      }
      if (HasDischarge) {
        output.WriteRawTag(26);
        output.WriteString(Discharge);
      }
      if (HasTotalChargedEnergy) {
        output.WriteRawTag(34);
        output.WriteString(TotalChargedEnergy);
      }
      if (HasTotalDischargedEnergy) {
        output.WriteRawTag(42);
        output.WriteString(TotalDischargedEnergy);
      }
      if (_unknownFields != null) {
        _unknownFields.WriteTo(ref output);
      }
    }
    #endif

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public int CalculateSize() {
      int size = 0;
      if (HasStateOfCharge) {
        size += 1 + pb::CodedOutputStream.ComputeInt32Size(StateOfCharge);
      }
      if (HasCharge) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Charge);
      }
      if (HasDischarge) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(Discharge);
      }
      if (HasTotalChargedEnergy) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(TotalChargedEnergy);
      }
      if (HasTotalDischargedEnergy) {
        size += 1 + pb::CodedOutputStream.ComputeStringSize(TotalDischargedEnergy);
      }
      if (_unknownFields != null) {
        size += _unknownFields.CalculateSize();
      }
      return size;
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(Battery other) {
      if (other == null) {
        return;
      }
      if (other.HasStateOfCharge) {
        StateOfCharge = other.StateOfCharge;
      }
      if (other.HasCharge) {
        Charge = other.Charge;
      }
      if (other.HasDischarge) {
        Discharge = other.Discharge;
      }
      if (other.HasTotalChargedEnergy) {
        TotalChargedEnergy = other.TotalChargedEnergy;
      }
      if (other.HasTotalDischargedEnergy) {
        TotalDischargedEnergy = other.TotalDischargedEnergy;
      }
      _unknownFields = pb::UnknownFieldSet.MergeFrom(_unknownFields, other._unknownFields);
    }

    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    public void MergeFrom(pb::CodedInputStream input) {
    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
      input.ReadRawMessage(this);
    #else
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, input);
            break;
          case 8: {
            StateOfCharge = input.ReadInt32();
            break;
          }
          case 18: {
            Charge = input.ReadString();
            break;
          }
          case 26: {
            Discharge = input.ReadString();
            break;
          }
          case 34: {
            TotalChargedEnergy = input.ReadString();
            break;
          }
          case 42: {
            TotalDischargedEnergy = input.ReadString();
            break;
          }
        }
      }
    #endif
    }

    #if !GOOGLE_PROTOBUF_REFSTRUCT_COMPATIBILITY_MODE
    [global::System.Diagnostics.DebuggerNonUserCodeAttribute]
    [global::System.CodeDom.Compiler.GeneratedCode("protoc", null)]
    void pb::IBufferMessage.InternalMergeFrom(ref pb::ParseContext input) {
      uint tag;
      while ((tag = input.ReadTag()) != 0) {
        switch(tag) {
          default:
            _unknownFields = pb::UnknownFieldSet.MergeFieldFrom(_unknownFields, ref input);
            break;
          case 8: {
            StateOfCharge = input.ReadInt32();
            break;
          }
          case 18: {
            Charge = input.ReadString();
            break;
          }
          case 26: {
            Discharge = input.ReadString();
            break;
          }
          case 34: {
            TotalChargedEnergy = input.ReadString();
            break;
          }
          case 42: {
            TotalDischargedEnergy = input.ReadString();
            break;
          }
        }
      }
    }
    #endif

  }

  #endregion

}

#endregion Designer generated code
